/*
 * Created on 23.06.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2446 $
 *  $Date: 2006-09-12 14:57:25 +0200 (Di, 12 Sep 2006) $
 *  $Id: DivisionOperation.java 2446 2006-09-12 12:57:25Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.Operations;

import com.vividsolutions.jump.feature.Feature;

import de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.FormulaValue;

/**
 * Class to handle divisions within a formula.
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2446 $
 * 
 */
public class DivisionOperation extends GenericOperation {

    /**
     *@inheritDoc
     */
    public DivisionOperation(FormulaValue value1, FormulaValue value2) {
        super(value1, value2);
        this.opString = "/";
    }
    
    /**
     * Returns the divided values of the sub-values or sub-operations of this operation
     *@param feature
     *@return divided values of the sub-values or sub-operations
     */
    public double getValue(Feature feature) {
        return this.value1.getValue(feature) / this.value2.getValue(feature);
    }

}
