/*
 * Created on 10.04.2006 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2588 $
 *  $Date: 2006-10-24 10:36:51 +0200 (Di, 24 Okt 2006) $
 *  $Id: Wgs84Projection.java 2588 2006-10-24 08:36:51Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.projection.Projections;

import de.fhOsnabrueck.jump.pirol.utilities.projection.ellipsoid.GRS80Ellipsoid;

/**
 * Describes a WGS84 projection
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2006),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2588 $
 * 
 */
public class Wgs84Projection extends AbstractProjection {
    
    public static final int ESRID_WGS84 = 4326;

    public Wgs84Projection() {
        super();
        this.setEllipsoid(new GRS80Ellipsoid());
    }

    /**
     *@inheritDoc
     */
    public int getSRID() {
        return ESRID_WGS84;
    }

    /**
     *@inheritDoc
     */
    String asString() {
        return AbstractProjection.KEY_WGS84;
    }

    public String toString() {
        return this.asString();
    }

}
